#!/usr/bin/ruby

pin_layer = {"M3L"=>13, "M4L"=>14, "M5L"=>15}
layer_name = "M3L"

f = open( ARGV[0] ) {|file|
  while l = file.gets
    # get pin name
    if /PIN ([\w\[\]]+)/ =~ l
      pin_name = $1
    end
    # get macro name 
    if /MACRO (\w+)/ =~ l
      macro_name = $1
    end
    # get Layer Number
    if /^\s*LAYER ([\w\[\]]+)/ =~ l 
      layer_name = $1.to_s;
    end
    # obs section is obstruction
    if /^\s+OBS$/ =~l 
      exit
    end
    if /RECT ([\d\.]+) ([\d\.]+) ([\d\.]+) ([\d\.]+)/ =~ l
      printf "LAYOUT TEXT \"%s\" %10.4f %10.4f %d %s\n", \
      pin_name, \
      ($1.to_f + $3.to_f)/2.0, \
      ($2.to_f + $4.to_f)/2.0, \
      pin_layer[layer_name], \
      macro_name
    end
  end
}
  

