#!/bin/csh -f

 setenv ACT_DIR		$PWD

 setenv MGC_HOME	/home/vdec/mentor/Calibre-2010.2_13.12/
 setenv tools_dir	/home/vdec/lib/ux8l/DesignFlow100831rev/sample_script/art_work/attachedfile/make_lvsnet/tools
 setenv OPC_PATH	/home/vdec/lib/ux8l
 setenv ROOT_PATH	./
 setenv OPC_ADD		/home/vdec/lib/ux8l/IO/OPC_ADD2
 setenv OPC_PLL		/home/vdec/lib/ux8l/PLL/linux
 setenv OPC_MODULE	./../pr/inst_mem/
 setenv TECHNOLOGY	UX8L
 setenv COND		wide1_1.1V
 setenv PRIM_DIR	${OPC_PATH}/blib/UX8L/wide1_1.1V/spice/primitive
 setenv RAM_DIR		./ram_s_lvstmp
 setenv PLLI_DIR	${OPC_ADD}/blib/UX8L/wide1_1.1V/spice/7L_30.096u_staggerWireCUP/add
 setenv PLLC_DIR	${OPC_PLL}/blib/UX8L/wide1_1.1V/spice/7L_30.096u_staggerWireCUP/add
 setenv IO_spice_dir	${OPC_ADD}/blib/UX8L/wide1_1.1V/spice/7L_30.096u_staggerWireCUP/ioblock

 setenv metal		./$1.lvs.v
 setenv fill_def	./$1.def.gz

 setenv out_file_def	out_file_def
 setenv CREATE_DATE	`date '+%Y%m%d'`
 setenv VER		001_${CREATE_DATE}
 setenv design_name	$1

 set ram_cell = ( `awk '{if(index($1,"WDREG")==1||index($1,"WDSRAM")==1){printf("%s\n",$1)}}' $metal | sort | uniq` )

##---- $BCf4V%U%!%$%k$r=PNO$5$;$k%G%#%l%/%H%j$r:n@.$7$^$9!#(B
#---------
  if ( ! -d work     ) mkdir work
  if ( ! -d work/LIB ) mkdir work/LIB
  if ( ! -d lib_work ) mkdir lib_work

  if ( ! -d ./ram_v_lvstmp ) mkdir ./ram_v_lvstmp
  if ( ! -d ./ram_s_lvstmp ) mkdir ./ram_s_lvstmp
#---------

##---- $B%T%s$P$i$7MQ%@%_!<(BRAM$B%b%8%e!<%k5-=R@8@.(B

echo '{' >! ./add_ram_lvs.awk

  foreach rcel ( $ram_cell )
     setenv RCEL $rcel

     setenv mem_v ${OPC_MODULE}${rcel}.v

     if ( ! -f $mem_v ) then
        echo '*** error *** not found : '$mem_v
        exit
     endif

     sed -e 's/\[/[ /g' \
         -e 's/\]/ ]/g' \
         -e 's/\;/ ;/g' \
         -e 's/\,/ ,/g' \
         -e 's/\=/ = /g' \
         $mem_v >! tmp1

     awk -f ${tools_dir}/gen_wrap.awk tmp1      >! ./ram_v_lvstmp/${rcel}_lvstmp.v
     awk -f ${tools_dir}/gen_ram_spice.awk tmp1 >! ./ram_s_lvstmp/${rcel}.spice
     /bin/rm ./tmp1

     echo 'if ( $1=="'${rcel}'" ) { $1="'${rcel}'_lvstmp" ; }' >> ./add_ram_lvs.awk

  end

  echo 'print($0) ;' >> ./add_ram_lvs.awk
  echo '}' >> ./add_ram_lvs.awk

  cat ./ram_v_lvstmp/WD*.v     >! ./ram_v_lvstmp/ram_all_lvstmp.v
  cat ./ram_s_lvstmp/WD*.spice >! ./ram_s_lvstmp/ram_all_lvstmp.spice

##---- AWK$B=hM}!J%T%s$P$i$7A0=hM}!K(B

awk -f ./add_ram_lvs.awk ${metal} >! ./${design_name}.lvs.v_mod

/bin/rm -rf add_ram_lvs.awk
/bin/rm -rf metal_$$

# source ${tools_dir}/dc_2007.03-SP4
unlimit stacksize
##---- DesiginCompiler$B$N<B9T!J%T%s$P$i$7=hM}!K$r$7$^$9!#(B

cat << ! > tmp_$$.tcl
  sh date
  set design_name "${design_name}"
  set OPC_PATH   "${OPC_PATH}"
  set TECHNOLOGY "${TECHNOLOGY}"
  set COND       "${COND}"
  set tools_dir  "${tools_dir}"
  set ROOT_PATH  "${ROOT_PATH}"
  set search_path [list . [format "%s%s"  $ROOT_PATH {/libraries/syn}] \
        $OPC_PATH/lib/${TECHNOLOGY}/${COND}/liberty_db/max \
        $OPC_ADD/lib/${TECHNOLOGY}/${COND}/liberty_db/max \
        $OPC_PLL/lib/${TECHNOLOGY}/${COND}/liberty_db/max \
        $OPC_MODULE/ \
        ]
  set link_library [list {*} \
        ${TECHNOLOGY}_${COND}_MAX_primitive_hvt.db \
        ${TECHNOLOGY}_${COND}_MAX_primitive_mvt.db \
        ${TECHNOLOGY}_${COND}_MAX_io_fe_mox33v.db \
        ${TECHNOLOGY}_${COND}-M_COM_MAX.db \
        ]
#         C0S8L0STARCIO_FE_ACPLMPHH38V10_MAX.db \
#         C0S8L0STARCIO_FE_ACPLIO38V10_MAX.db \

  set target_library [list \
        ${TECHNOLOGY}_${COND}_MAX_primitive_hvt.db \
        ${TECHNOLOGY}_${COND}_MAX_primitive_mvt.db \
        ${TECHNOLOGY}_${COND}-M_COM_MAX.db \
        ]
#         C0S8L0STARCIO_FE_ACPLMPHH38V10_MAX.db \
#         C0S8L0STARCIO_FE_ACPLIO38V10_MAX.db \

  set verilogout_no_tri {true}
  set test_stil_netlist_format {verilog}
  set test_default_delay 0.0
  set test_default_bidir_delay 0.0
  set test_default_strobe 199.0
  set test_default_period 200.0
  set cache_read  "./lib_work"
  set cache_write "./lib_work"

  define_design_lib WORK -path ./work/LIB
  define_name_rules "OpenCAD" -max_length "255" -allowed "{a-zA-Z0-9_\$.&<=>@^\`|~}" -type cell
  define_name_rules "OpenCAD" -max_length "255" -allowed "{a-zA-Z0-9_\$\[\]}" -type port
  define_name_rules "OpenCAD" -max_length "255" -allowed "{a-zA-Z0-9_\$.&<=>@^\`|~}" -type net
  define_name_rules "OpenCAD" -case_insensitive -remove_internal_net_bus -remove_port_bus -special verilog
  define_name_rules "OpenCAD-TOP" -max_length "64" -allowed "A-Z0-9_" -type port
  define_name_rules "OpenCAD-TOP" -case_insensitive -remove_port_bus -special verilog

  # source  $OPC_PATH/lib/${TECHNOLOGY}/$COND/liberty_db/script/NAME_RULE.tcl

  read_file -format verilog ${design_name}.lvs.v_mod
  read_file -format verilog ./ram_v_lvstmp/ram_all_lvstmp.v
  elaborate ${design_name}
  current_design ${design_name}
  link
  set_fix_multiple_port_nets -all -buffer_constants
  # change_names -rules OpenCAD-TOP -log_changes "./report/${design_name}_OpenCAD-TOP.log"
  change_names -rules OpenCAD -hierarchy -log_changes "./report/${design_name}_OpenCAD.log"
  # change_names -rules verilog -hier
  write -f verilog -hierarchy -o ./${design_name}-bus_expand.v
  sh date
  exit
!

dc_shell-t -f tmp_$$.tcl | tee ./dc_${design_name}_ux8l_bus_expand.log

/bin/rm -f  tmp_$$.tcl

/bin/mv ./${design_name}-bus_expand.v ./${design_name}-bus_expand.v_org

##---- AWK$B=hM}!J%T%s$P$i$78e=hM}!K(B

awk -f ${tools_dir}/delete_mem_lvs_module.awk ./${design_name}-bus_expand.v_org >! ./${design_name}-bus_expand.v

/bin/rm -rf delete_mem_lvs_module.awk
/bin/rm -rf work lib_work
/bin/rm -rf ${design_name}-bus_expand.v_org
/bin/rm -rf ${design_name}.lvs.v_mod

#exit

##---- SOC Encounter $B$+$i=PNO$5$l$?(Bfill_def$B$r2rE`$9$k!((Bgunzip)
cp ${fill_def} fill_def_tmp_$$.gz
# cp ${fill_def} fill_def_tmp_$$
gunzip fill_def_tmp_$$.gz

##---- SOC Encounter $B$+$i=PNO$5$l$?(Bverilog$B$K$J$$(B
##---- $B%M%C%H>pJs(B(IO$BIt$N(BVDD33$BC<;R(B,IO$BIt$N%U%#%k%;%k(B,IO$BIt$NEE8;%;%k(B,$B%3!<%J!<%;%k(B,logic$BIt$N%U%#%k%;%k!K$rIU2C$7$^$9!#(B
cat << ! > sed_pcc
/^COMPONENTS /,/^END COMPONEN/p
!

sed -n -f sed_pcc fill_def_tmp_$$ | \
grep "^-"  | awk '{print $1,$2,$3}' > fill_def_tmp_comp_$$

grep C0S8L0STARCIO_FE_TWF1SFCELL33   fill_def_tmp_comp_$$ | awk '{printf("X%s VDD VDD33 VSS %s\n",$2,$3)}'       >  ${out_file_def}
grep C0S8L0STARCIO_FE_TWF1SGND33O    fill_def_tmp_comp_$$ | awk '{printf("X%s GND VDD VDD33 VSS %s\n",$2,$3)}'   >> ${out_file_def}
grep C0S8L0STARCIO_FE_TWF1SGND33I    fill_def_tmp_comp_$$ | awk '{printf("X%s GND VDD VDD33 VSS %s\n",$2,$3)}'   >> ${out_file_def}
grep C0S8L0STARCIO_FE_TWF1SGND33W    fill_def_tmp_comp_$$ | awk '{printf("X%s GND GND VDD VDD33 VSS %s\n",$2,$3)}' >> ${out_file_def}
grep C0S8L0STARCIO_FE_TWF1SVDD11A33W fill_def_tmp_comp_$$ | awk '{printf("X%s VDD VDD VDD VSS %s\n",$2,$3)}'     >> ${out_file_def}
grep C0S8L0STARCIO_FE_TWF1SVDD11A33I fill_def_tmp_comp_$$ | awk '{printf("X%s VDD VDD VSS %s\n",$2,$3)}'         >> ${out_file_def}
grep C0S8L0STARCIO_FE_TWF1SVDD33     fill_def_tmp_comp_$$ | awk '{printf("X%s VDD VDD33 VDD33 VSS %s\n",$2,$3)}' >> ${out_file_def}
grep C0S8L0STARCIO_FE_TWF1SBLBUFF    fill_def_tmp_comp_$$ | awk '{printf("X%s VDD VSS %s\n",$2,$3)}'             >> ${out_file_def}
grep C0S8L0STARCIO_FE_TWF1SBRBUFF    fill_def_tmp_comp_$$ | awk '{printf("X%s VDD VSS %s\n",$2,$3)}'             >> ${out_file_def}
grep C0S8L0STARCIO_FE_TWF1STLBUFF    fill_def_tmp_comp_$$ | awk '{printf("X%s VDD VSS %s\n",$2,$3)}'             >> ${out_file_def}
grep C0S8L0STARCIO_FE_TWF1STRBUFF    fill_def_tmp_comp_$$ | awk '{printf("X%s VDD VSS %s\n",$2,$3)}'             >> ${out_file_def}
grep LDL_FILL64GC1                   fill_def_tmp_comp_$$ | awk '{printf("X%s VDD VSS %s\n",$2,$3)}'             >> ${out_file_def}
grep LDL_FILL32GC1                   fill_def_tmp_comp_$$ | awk '{printf("X%s VDD VSS %s\n",$2,$3)}'             >> ${out_file_def}
grep LDL_FILL16GC1                   fill_def_tmp_comp_$$ | awk '{printf("X%s VDD VSS %s\n",$2,$3)}'             >> ${out_file_def}
grep LDL_FILL8GC1                    fill_def_tmp_comp_$$ | awk '{printf("X%s VDD VSS %s\n",$2,$3)}'             >> ${out_file_def}

/bin/rm -rf fill_def_tmp_$$ fill_def_tmp_comp_$$ sed_pcc

pushd .
cd  ${PRIM_DIR} 
cat LD* > ${ACT_DIR}/primitive.spice_$$
popd

cat primitive.spice_$$ ${PLLI_DIR}/* ${PLLC_DIR}/* ${RAM_DIR}/ram_all_lvstmp.spice  ${IO_spice_dir}/*spice > all.spi

/bin/rm -rf  primitive.spice_$$


##---- $B%T%s$P$i$7$N=hM}$r$7$?(Bverilog$B$+$iC<;R>pJs$,$J$$%^%/%m(B(IO$BIt$N%U%#%k%;%k!"(Blogic$BIt$N%U%#%k%;%k(B)
##---- $B:o=|$9$k!#(B($B8e9TDx$N(Bv2lvs$B$GCWL?E*$J%(%i!<$H$J$k$?$a!#!K(B
grep -v TWF1SFCELL33 ./${design_name}-bus_expand.v |\
grep -v LDL_FILL64GC1  |\
grep -v LDL_FILL32GC1  |\
grep -v LDL_FILL16GC1  |\
grep -v LDL_FILL8GC1  |\
grep -v LDL_FILL4GC1  |\
grep -v LDL_FILL2GC1  |\
grep -v XXXXXXXXXXXXX  > ${design_name}.lvs.v2_$$

/bin/rm -rf ${design_name}-bus_expand.v

##---- v2lvs$B$N<B9T(B
${MGC_HOME}/bin/v2lvs -64  -i  -a -n \
-addpin VDD \
-addpin VSS \
-v ${design_name}.lvs.v2_$$ \
-lsp all.spi \
-lsr all.spi \
-o Design_for_LVS.spi_noprim >& v2lvs.log

cat all.spi  Design_for_LVS.spi_noprim > lvsnet

##---- spice$B%M%C%H%j%9%H$N9TF,$N(B"+"$BI=8=$J$/$7!"0l9T$K$7$^$9!#(B
sed -e 's/+/+ /' -e 's/ W=/ W= /' -e 's/ L=/ L= /' -e 's/ M=/ M= /' lvsnet > spice_tmp1_$$
awk -f ${tools_dir}/spice_join.awk spice_tmp1_$$ > spice_tmp2_$$

##---- $B%U%!%$%k$N:G8e$N9T$r:o=|$7$^$9!#(B
##---- IO$BIt$N%U%#%k%;%k!"(Blogic$BIt$N%U%#%k%;%k$N>pJs$rIU2C$9$k$?$a!":G8e$N9T$N(B .END$BJ8$r:o=|$7$^$9!#(B
cat << ! > perl_$$
#!/usr/bin/perl
\$INFILE=\$ARGV[0]; \$OUTFILE=\$ARGV[1]; open(IN, "\$INFILE"); open(OUT,">\$OUTFILE") ;
while(<IN>){ chomp; split ; push(@tmp,\$_); } pop(@tmp); foreach \$a(@tmp){ print OUT "\$a\n"; } close(IN); close(OUT);
!
chmod 777 perl_$$
perl_$$ spice_tmp2_$$ spice_tmp3_$$

##---- $B%U%!%$%k$N:G8e$N9T$rCj=P$7$^$9!#(B
tail -1     spice_tmp2_$$ > spice_tmp4_$$

##---- $B%U%!%$%k$N7k9g(B
cat spice_tmp3_$$ out_file_def  spice_tmp4_$$ > spice_tmp5_$$

##---- IO$BIt$N%P%C%U%!$K(BVDD33$BC<;R$rIU2C$7$^$9!#(B
awk '{  if ( $7  == "C0S8L0STARCIO_FE_TWF1IC33AS" )      { printf ( "%s %s %s %s VDD33 %s %s\n",$1,$2,$3,$4,$6,$7) } \
   else if ( $7  == "C0S8L0STARCIO_FE_TWF1IC33ASS" )     { printf ( "%s %s %s %s VDD33 %s %s\n",$1,$2,$3,$4,$6,$7) } \
   else if ( $12 == "C0S8L0STARCIO_FE_TWF1BC33ALV04SZ")  { printf ( "%s %s %s %s %s %s %s %s %s VDD33 %s %s\n",$1,$2,$3,$4,$5,$6,$7,$8,$9,$11,$12) }  \
   else if ( $12 == "C0S8L0STARCIO_FE_TWF1BC33ANV04SZ")  { printf ( "%s %s %s %s %s %s %s %s %s VDD33 %s %s\n",$1,$2,$3,$4,$5,$6,$7,$8,$9,$11,$12) }  \
   else if ( $12 == "C0S8L0STARCIO_FE_TWF1BC33ASLV04SZ") { printf ( "%s %s %s %s %s %s %s %s %s VDD33 %s %s\n",$1,$2,$3,$4,$5,$6,$7,$8,$9,$11,$12) }  \
   else if ( $12 == "C0S8L0STARCIO_FE_TWF1BC33ASNV04SZ") { printf ( "%s %s %s %s %s %s %s %s %s VDD33 %s %s\n",$1,$2,$3,$4,$5,$6,$7,$8,$9,$11,$12) }  \
   else if ( $7  == "C0S8L0STARCIO_FE_TWF1IC11AS_DIO")   { printf ( "%s %s %s %s VDD33 %s %s\n",$1,$2,$3,$4,$6,$7) }  \
   else if ( $7  == "C0S8L0STARCIO_FE_TWF1IC33AS_DIO")   { printf ( "%s %s %s %s VDD33 %s %s\n",$1,$2,$3,$4,$6,$7) }  \
   else  print $0 }'  < spice_tmp5_$$ > spice_tmp6_$$

##---- $B%H%C%W2sO)$N30ItC<;R(BVDD33$B$rIU2C$7$^$9!#(B
#sed 's|SUBCKT '${design_name}' |SUBCKT '${design_name}' VDD33 |g'  < spice_tmp6_$$ > ${design_name}_${VER}.spice
sed 's|SUBCKT '${design_name}' |SUBCKT '${design_name}' VDD33 |g'  < spice_tmp6_$$ > ${design_name}.spice

/bin/rm -rf spice_tmp1_$$ spice_tmp2_$$ spice_tmp3_$$ spice_tmp4_$$ spice_tmp5_$$ spice_tmp6_$$  perl_$$  out_file_def

##---- $B=PNO%U%!%$%k(B(LVS$B%M%C%H%j%9%H(B)$B$N%U%)!<%^%C%H%A%'%C%/$r<B9T$7$^$9!#(B

cat << ! > netlist_check_cal.rule
//--------------------------------------------------------------------
  TITLE "RULE FILE TITLE (NETLIST CHECK)"
//--------------------------------------------------------------------
//====================================================================
  SOURCE PATH    "${design_name}.spice"           // SCHEMATIC FILE PATH and NAME
  SOURCE PRIMARY "${design_name}"           // TOP CIRCUIT NAME
  SOURCE SYSTEM  SPICE                   // INPUT SCHEMATIC FORMAT
  LVS    REPORT  "netlist_check.rep"     // LVS REPORT FILE NAME
//=========================================================== END
!

calibre -lvs -cs netlist_check_cal.rule

/bin/rm -rf primitive_$$.spice
/bin/rm -rf ${design_name}.lvs.v2_$$
/bin/rm -rf lvsnet 
/bin/rm -rf all.spi
/bin/rm -rf Design_for_LVS.spi_noprim
/bin/rm -rf ram_s_lvstmp ram_v_lvstmp
