#!/usr/bin/env ruby

######################################################################
# connect filler and IO Pad
#   VNW=VNW -> VNW=your_VDD  : .VDD(your_VDD)
#   VPW=VPW -> VPW=VSS
#   VDD=<right VDD>
# usage:
#   ./connect <input.cdl> <output.cdl>
######################################################################

######################################################################
# setting
######################################################################
CORE    = 0
BRIDGE  = 1
pad_tbl = {}

######################################################################
# _PAD define
######################################################################
# bottom ###################################################
pad_tbl["XCORNER_B_L_PAD"]      = CORE
pad_tbl["XVSS_SPACE_B0_PAD"]    = CORE
pad_tbl["XDUMPDONE_PAD"]        = CORE
pad_tbl["XTRANS_MODE_PAD"]      = CORE
pad_tbl["XVDE_B0_PAD"]          = CORE
pad_tbl["XVSS_B0_PAD"]          = CORE
pad_tbl["XCORE_VDD_B0_PAD"]     = CORE
pad_tbl["XWRITE_PAD"]           = CORE
pad_tbl["XSTROBE_PAD"]          = CORE
pad_tbl["XBLOCK_PAD"]           = CORE
pad_tbl["XG_BYTEENABLE_0_PAD"]  = CORE
pad_tbl["XG_BYTEENABLE_1_PAD"]  = CORE
pad_tbl["XG_BYTEENABLE_2_PAD"]  = CORE
pad_tbl["XG_BYTEENABLE_3_PAD"]  = CORE
pad_tbl["XCORE_VDD_B1_PAD"]     = CORE
pad_tbl["XVSS_B1_PAD"]          = CORE
# devider ##################################################
pad_tbl["XOUT_DA_0_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_1_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_2_PAD"]        = BRIDGE
pad_tbl["XCLK1_PAD"]            = BRIDGE
pad_tbl["XOUT_DA_3_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_4_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_5_PAD"]        = BRIDGE
pad_tbl["XBRIDGE_VDD_B0_PAD"]   = BRIDGE
pad_tbl["XVDE_B1_PAD"]          = BRIDGE
pad_tbl["XVSS_B2_PAD"]          = BRIDGE
pad_tbl["XOUT_DA_6_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_7_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_8_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_9_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_10_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_11_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_12_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_13_PAD"]       = BRIDGE
pad_tbl["XVSS_B3_PAD"]          = BRIDGE
pad_tbl["XBRIDGE_VDD_B1_PAD"]   = BRIDGE
pad_tbl["XOUT_DA_14_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_15_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_16_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_17_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_18_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_19_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_20_PAD"]       = BRIDGE
pad_tbl["XBRIDGE_VDD_B2_PAD"]   = BRIDGE
pad_tbl["XVSS_B4_PAD"]          = BRIDGE
pad_tbl["XVDE_B2_PAD"]          = BRIDGE
pad_tbl["XOUT_DA_21_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_22_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_23_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_24_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_25_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_26_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_27_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_28_PAD"]       = BRIDGE
pad_tbl["XVSS_B5_PAD"]          = BRIDGE
pad_tbl["XBRIDGE_VDD_B3_PAD"]   = BRIDGE
pad_tbl["XOUT_DA_29_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_30_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_31_PAD"]       = BRIDGE
# right ####################################################
pad_tbl["XCORNER_B_R_PAD"]      = BRIDGE
pad_tbl["XLEAKRESET__PAD"]      = BRIDGE
pad_tbl["XLEAKSET_PAD"]         = BRIDGE
pad_tbl["XLEAKSTART_PAD"]       = BRIDGE
pad_tbl["XLEAKDATA_PAD"]        = BRIDGE
pad_tbl["XDMISS_PAD"]           = BRIDGE
pad_tbl["XVDE_R0_PAD"]          = BRIDGE
pad_tbl["XVSS_R0_PAD"]          = BRIDGE
pad_tbl["XLEAKREADY_PAD"]       = BRIDGE
pad_tbl["XDHIT_PAD"]            = BRIDGE
pad_tbl["XIMISS_PAD"]           = BRIDGE
pad_tbl["XIHIT_PAD"]            = BRIDGE
pad_tbl["XDTLBMISS_PAD"]        = BRIDGE
pad_tbl["XDTLBHIT_PAD"]         = BRIDGE
pad_tbl["XITLBMISS_PAD"]        = BRIDGE
pad_tbl["XITLBHIT_PAD"]         = BRIDGE
pad_tbl["XVSS_R1_PAD"]          = BRIDGE
pad_tbl["XBRIDGE_VDD_R1_PAD"]   = BRIDGE
pad_tbl["XIN_D_31_PAD"]         = BRIDGE
pad_tbl["XIN_D_30_PAD"]         = BRIDGE
pad_tbl["XIN_D_29_PAD"]         = BRIDGE
pad_tbl["XIN_D_28_PAD"]         = BRIDGE
pad_tbl["XIN_D_27_PAD"]         = BRIDGE
pad_tbl["XIN_D_26_PAD"]         = BRIDGE
# top ######################################################"
pad_tbl["XVSS_SPACE_T0_PAD"]    = CORE
pad_tbl["XVSS_SPACE_T1_PAD"]    = CORE
pad_tbl["XVSS_SPACE_T2_PAD"]    = CORE
pad_tbl["XCORE_VDD_T0_PAD"]     = CORE
pad_tbl["XVSS_T0_PAD"]          = CORE
pad_tbl["XHARD_INT_5_PAD"]      = CORE
pad_tbl["XHARD_INT_4_PAD"]      = CORE
pad_tbl["XHARD_INT_3_PAD"]      = CORE
pad_tbl["XHARD_INT_2_PAD"]      = CORE
pad_tbl["XHARD_INT_1_PAD"]      = CORE
pad_tbl["XHARD_INT_0_PAD"]      = CORE
pad_tbl["XNMI__PAD"]            = CORE
pad_tbl["XTLB_EN_PAD"]          = CORE
pad_tbl["XVDE_T0_PAD"]          = CORE
pad_tbl["XVSS_T1_PAD"]          = CORE
pad_tbl["XCORE_VDD_T1_PAD"]     = CORE
# divider ##################################################
pad_tbl["XCACHE_EN_PAD"]        = BRIDGE
pad_tbl["XMEMORYDUMP_PAD"]      = BRIDGE
pad_tbl["XCLK_PAD"]             = BRIDGE
pad_tbl["XRESET__PAD"]          = BRIDGE
pad_tbl["XBUS_ERR_PAD"]         = BRIDGE
pad_tbl["XREADY_PAD"]           = BRIDGE
pad_tbl["XIN_D_0_PAD"]          = BRIDGE
pad_tbl["XBRIDGE_VDD_T0_PAD"]   = BRIDGE
pad_tbl["XVSS_T2_PAD"]          = BRIDGE
pad_tbl["XIN_D_1_PAD"]          = BRIDGE
pad_tbl["XIN_D_2_PAD"]          = BRIDGE
pad_tbl["XIN_D_3_PAD"]          = BRIDGE
pad_tbl["XIN_D_4_PAD"]          = BRIDGE
pad_tbl["XIN_D_5_PAD"]          = BRIDGE
pad_tbl["XIN_D_6_PAD"]          = BRIDGE
pad_tbl["XIN_D_7_PAD"]          = BRIDGE
pad_tbl["XBRIDGE_VDD_T1_PAD"]   = BRIDGE
pad_tbl["XVSS_T3_PAD"]          = BRIDGE
pad_tbl["XVDE_T1_PAD"]          = BRIDGE
pad_tbl["XIN_D_8_PAD"]          = BRIDGE
pad_tbl["XIN_D_9_PAD"]          = BRIDGE
pad_tbl["XIN_D_10_PAD"]         = BRIDGE
pad_tbl["XIN_D_11_PAD"]         = BRIDGE
pad_tbl["XIN_D_12_PAD"]         = BRIDGE
pad_tbl["XIN_D_13_PAD"]         = BRIDGE
pad_tbl["XIN_D_14_PAD"]         = BRIDGE
pad_tbl["XIN_D_15_PAD"]         = BRIDGE
pad_tbl["XVSS_T4_PAD"]          = BRIDGE
pad_tbl["XBRIDGE_VDD_T2_PAD"]   = BRIDGE
pad_tbl["XIN_D_16_PAD"]         = BRIDGE
pad_tbl["XIN_D_17_PAD"]         = BRIDGE
pad_tbl["XIN_D_18_PAD"]         = BRIDGE
pad_tbl["XIN_D_19_PAD"]         = BRIDGE
pad_tbl["XIN_D_20_PAD"]         = BRIDGE
pad_tbl["XIN_D_21_PAD"]         = BRIDGE
pad_tbl["XIN_D_22_PAD"]         = BRIDGE
pad_tbl["XBRIDGE_VDD_T3_PAD"]   = BRIDGE
pad_tbl["XVSS_T5_PAD"]          = BRIDGE
pad_tbl["XVDE_T2_PAD"]          = BRIDGE
pad_tbl["XIN_D_23_PAD"]         = BRIDGE
pad_tbl["XIN_D_24_PAD"]         = BRIDGE
pad_tbl["XIN_D_25_PAD"]         = BRIDGE
pad_tbl["XCORNER_T_R_PAD"]      = BRIDGE
# left #####################################################
pad_tbl["XVSS_SPACE_L0_PAD"]    = CORE
pad_tbl["XVSS_SPACE_L1_PAD"]    = CORE
pad_tbl["XVSS_SPACE_L2_PAD"]    = CORE
pad_tbl["XVSS_SPACE_L3_PAD"]    = CORE
pad_tbl["XVSS_SPACE_L4_PAD"]    = CORE
pad_tbl["XVSS_SPACE_L5_PAD"]    = CORE
pad_tbl["XCORE_VDD_L0_PAD"]     = CORE
pad_tbl["XVSS_L0_PAD"]          = CORE
pad_tbl["XVSS_SPACE_L6_PAD"]    = CORE
pad_tbl["XSLEEPCON_0_PAD"]      = CORE
pad_tbl["XSLEEPCON_1_PAD"]      = CORE
pad_tbl["XSLEEPCON_2_PAD"]      = CORE
pad_tbl["XSLEEPCON_3_PAD"]      = CORE
pad_tbl["XCP0_CON_PAD"]         = CORE
pad_tbl["XVSS_SPACE_L7_PAD"]    = CORE
pad_tbl["XCORE_VDD_L1_PAD"]     = CORE
pad_tbl["XVSS_L1_PAD"]          = CORE
pad_tbl["XVDE_L0_PAD"]          = CORE
pad_tbl["XVSS_SPACE_L8_PAD"]    = CORE
pad_tbl["XVSS_SPACE_L9_PAD"]    = CORE
pad_tbl["XVSS_SPACE_L10_PAD"]   = CORE
pad_tbl["XVSS_SPACE_L11_PAD"]   = CORE
pad_tbl["XVSS_SPACE_L12_PAD"]   = CORE
pad_tbl["XCORNER_T_L_PAD"]      = CORE

######################################################################
# _WIRE_PAD define
######################################################################
# bottom ###################################################
pad_tbl["XCORNER_B_L_WIRE_PAD"]      = CORE
pad_tbl["XVSS_SPACE_B0_WIRE_PAD"]    = CORE
pad_tbl["XDUMPDONE_WIRE_PAD"]        = CORE
pad_tbl["XTRANS_MODE_WIRE_PAD"]      = CORE
pad_tbl["XVDE_B0_WIRE_PAD"]          = CORE
pad_tbl["XVSS_B0_WIRE_PAD"]          = CORE
pad_tbl["XCORE_VDD_B0_WIRE_PAD"]     = CORE
pad_tbl["XWRITE_WIRE_PAD"]           = CORE
pad_tbl["XSTROBE_WIRE_PAD"]          = CORE
pad_tbl["XBLOCK_WIRE_PAD"]           = CORE
pad_tbl["XG_BYTEENABLE_0_WIRE_PAD"]  = CORE
pad_tbl["XG_BYTEENABLE_1_WIRE_PAD"]  = CORE
pad_tbl["XG_BYTEENABLE_2_WIRE_PAD"]  = CORE
pad_tbl["XG_BYTEENABLE_3_WIRE_PAD"]  = CORE
pad_tbl["XCORE_VDD_B1_WIRE_PAD"]     = CORE
pad_tbl["XVSS_B1_WIRE_PAD"]          = CORE
# devider ##################################################
pad_tbl["XOUT_DA_0_WIRE_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_1_WIRE_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_2_WIRE_PAD"]        = BRIDGE
pad_tbl["XCLK1_WIRE_PAD"]            = BRIDGE
pad_tbl["XOUT_DA_3_WIRE_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_4_WIRE_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_5_WIRE_PAD"]        = BRIDGE
pad_tbl["XBRIDGE_VDD_B0_WIRE_PAD"]   = BRIDGE
pad_tbl["XVDE_B1_WIRE_PAD"]          = BRIDGE
pad_tbl["XVSS_B2_WIRE_PAD"]          = BRIDGE
pad_tbl["XOUT_DA_6_WIRE_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_7_WIRE_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_8_WIRE_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_9_WIRE_PAD"]        = BRIDGE
pad_tbl["XOUT_DA_10_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_11_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_12_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_13_WIRE_PAD"]       = BRIDGE
pad_tbl["XVSS_B3_WIRE_PAD"]          = BRIDGE
pad_tbl["XBRIDGE_VDD_B1_WIRE_PAD"]   = BRIDGE
pad_tbl["XOUT_DA_14_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_15_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_16_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_17_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_18_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_19_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_20_WIRE_PAD"]       = BRIDGE
pad_tbl["XBRIDGE_VDD_B2_WIRE_PAD"]   = BRIDGE
pad_tbl["XVSS_B4_WIRE_PAD"]          = BRIDGE
pad_tbl["XVDE_B2_WIRE_PAD"]          = BRIDGE
pad_tbl["XOUT_DA_21_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_22_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_23_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_24_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_25_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_26_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_27_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_28_WIRE_PAD"]       = BRIDGE
pad_tbl["XVSS_B5_WIRE_PAD"]          = BRIDGE
pad_tbl["XBRIDGE_VDD_B3_WIRE_PAD"]   = BRIDGE
pad_tbl["XOUT_DA_29_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_30_WIRE_PAD"]       = BRIDGE
pad_tbl["XOUT_DA_31_WIRE_PAD"]       = BRIDGE
# right ####################################################
pad_tbl["XCORNER_B_R_WIRE_PAD"]      = BRIDGE
pad_tbl["XLEAKRESET__WIRE_PAD"]      = BRIDGE
pad_tbl["XLEAKSET_WIRE_PAD"]         = BRIDGE
pad_tbl["XLEAKSTART_WIRE_PAD"]       = BRIDGE
pad_tbl["XLEAKDATA_WIRE_PAD"]        = BRIDGE
pad_tbl["XDMISS_WIRE_PAD"]           = BRIDGE
pad_tbl["XVDE_R0_WIRE_PAD"]          = BRIDGE
pad_tbl["XVSS_R0_WIRE_PAD"]          = BRIDGE
pad_tbl["XLEAKREADY_WIRE_PAD"]       = BRIDGE
pad_tbl["XDHIT_WIRE_PAD"]            = BRIDGE
pad_tbl["XIMISS_WIRE_PAD"]           = BRIDGE
pad_tbl["XIHIT_WIRE_PAD"]            = BRIDGE
pad_tbl["XDTLBMISS_WIRE_PAD"]        = BRIDGE
pad_tbl["XDTLBHIT_WIRE_PAD"]         = BRIDGE
pad_tbl["XITLBMISS_WIRE_PAD"]        = BRIDGE
pad_tbl["XITLBHIT_WIRE_PAD"]         = BRIDGE
pad_tbl["XVSS_R1_WIRE_PAD"]          = BRIDGE
pad_tbl["XBRIDGE_VDD_R1_WIRE_PAD"]   = BRIDGE
pad_tbl["XIN_D_31_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_30_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_29_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_28_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_27_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_26_WIRE_PAD"]         = BRIDGE
# top ######################################################"
pad_tbl["XVSS_SPACE_T0_WIRE_PAD"]    = CORE
pad_tbl["XVSS_SPACE_T1_WIRE_PAD"]    = CORE
pad_tbl["XVSS_SPACE_T2_WIRE_PAD"]    = CORE
pad_tbl["XCORE_VDD_T0_WIRE_PAD"]     = CORE
pad_tbl["XVSS_T0_WIRE_PAD"]          = CORE
pad_tbl["XHARD_INT_5_WIRE_PAD"]      = CORE
pad_tbl["XHARD_INT_4_WIRE_PAD"]      = CORE
pad_tbl["XHARD_INT_3_WIRE_PAD"]      = CORE
pad_tbl["XHARD_INT_2_WIRE_PAD"]      = CORE
pad_tbl["XHARD_INT_1_WIRE_PAD"]      = CORE
pad_tbl["XHARD_INT_0_WIRE_PAD"]      = CORE
pad_tbl["XNMI__WIRE_PAD"]            = CORE
pad_tbl["XTLB_EN_WIRE_PAD"]          = CORE
pad_tbl["XVDE_T0_WIRE_PAD"]          = CORE
pad_tbl["XVSS_T1_WIRE_PAD"]          = CORE
pad_tbl["XCORE_VDD_T1_WIRE_PAD"]     = CORE
# divider ##################################################
pad_tbl["XCACHE_EN_WIRE_PAD"]        = BRIDGE
pad_tbl["XMEMORYDUMP_WIRE_PAD"]      = BRIDGE
pad_tbl["XCLK_WIRE_PAD"]             = BRIDGE
pad_tbl["XRESET__WIRE_PAD"]          = BRIDGE
pad_tbl["XBUS_ERR_WIRE_PAD"]         = BRIDGE
pad_tbl["XREADY_WIRE_PAD"]           = BRIDGE
pad_tbl["XIN_D_0_WIRE_PAD"]          = BRIDGE
pad_tbl["XBRIDGE_VDD_T0_WIRE_PAD"]   = BRIDGE
pad_tbl["XVSS_T2_WIRE_PAD"]          = BRIDGE
pad_tbl["XIN_D_1_WIRE_PAD"]          = BRIDGE
pad_tbl["XIN_D_2_WIRE_PAD"]          = BRIDGE
pad_tbl["XIN_D_3_WIRE_PAD"]          = BRIDGE
pad_tbl["XIN_D_4_WIRE_PAD"]          = BRIDGE
pad_tbl["XIN_D_5_WIRE_PAD"]          = BRIDGE
pad_tbl["XIN_D_6_WIRE_PAD"]          = BRIDGE
pad_tbl["XIN_D_7_WIRE_PAD"]          = BRIDGE
pad_tbl["XBRIDGE_VDD_T1_WIRE_PAD"]   = BRIDGE
pad_tbl["XVSS_T3_WIRE_PAD"]          = BRIDGE
pad_tbl["XVDE_T1_WIRE_PAD"]          = BRIDGE
pad_tbl["XIN_D_8_WIRE_PAD"]          = BRIDGE
pad_tbl["XIN_D_9_WIRE_PAD"]          = BRIDGE
pad_tbl["XIN_D_10_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_11_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_12_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_13_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_14_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_15_WIRE_PAD"]         = BRIDGE
pad_tbl["XVSS_T4_WIRE_PAD"]          = BRIDGE
pad_tbl["XBRIDGE_VDD_T2_WIRE_PAD"]   = BRIDGE
pad_tbl["XIN_D_16_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_17_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_18_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_19_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_20_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_21_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_22_WIRE_PAD"]         = BRIDGE
pad_tbl["XBRIDGE_VDD_T3_WIRE_PAD"]   = BRIDGE
pad_tbl["XVSS_T5_WIRE_PAD"]          = BRIDGE
pad_tbl["XVDE_T2_WIRE_PAD"]          = BRIDGE
pad_tbl["XIN_D_23_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_24_WIRE_PAD"]         = BRIDGE
pad_tbl["XIN_D_25_WIRE_PAD"]         = BRIDGE
pad_tbl["XCORNER_T_R_WIRE_PAD"]      = BRIDGE
# left #####################################################
pad_tbl["XVSS_SPACE_L0_WIRE_PAD"]    = CORE
pad_tbl["XVSS_SPACE_L1_WIRE_PAD"]    = CORE
pad_tbl["XVSS_SPACE_L2_WIRE_PAD"]    = CORE
pad_tbl["XVSS_SPACE_L3_WIRE_PAD"]    = CORE
pad_tbl["XVSS_SPACE_L4_WIRE_PAD"]    = CORE
pad_tbl["XVSS_SPACE_L5_WIRE_PAD"]    = CORE
pad_tbl["XCORE_VDD_L0_WIRE_PAD"]     = CORE
pad_tbl["XVSS_L0_WIRE_PAD"]          = CORE
pad_tbl["XVSS_SPACE_L6_WIRE_PAD"]    = CORE
pad_tbl["XSLEEPCON_0_WIRE_PAD"]      = CORE
pad_tbl["XSLEEPCON_1_WIRE_PAD"]      = CORE
pad_tbl["XSLEEPCON_2_WIRE_PAD"]      = CORE
pad_tbl["XSLEEPCON_3_WIRE_PAD"]      = CORE
pad_tbl["XCP0_CON_WIRE_PAD"]         = CORE
pad_tbl["XVSS_SPACE_L7_WIRE_PAD"]    = CORE
pad_tbl["XCORE_VDD_L1_WIRE_PAD"]     = CORE
pad_tbl["XVSS_L1_WIRE_PAD"]          = CORE
pad_tbl["XVDE_L0_WIRE_PAD"]          = CORE
pad_tbl["XVSS_SPACE_L8_WIRE_PAD"]    = CORE
pad_tbl["XVSS_SPACE_L9_WIRE_PAD"]    = CORE
pad_tbl["XVSS_SPACE_L10_WIRE_PAD"]   = CORE
pad_tbl["XVSS_SPACE_L11_WIRE_PAD"]   = CORE
pad_tbl["XVSS_SPACE_L12_WIRE_PAD"]   = CORE
pad_tbl["XCORNER_T_L_WIRE_PAD"]      = CORE


######################################################################
# argument check
######################################################################
if (ARGV.size < 2) then
  puts("connect filler and IO pad                                       ")
  puts("  VNW=VNW -> VNW=your_VDD  : .VDD(your_VDD)                     ")
  puts("  VPW=VPW -> VPW=VSS                                            ")
  puts("  VDD=VDD -> VDD=right VDD                                      ")
  puts("usage:                                                          ")
  puts("  ./connect.rb <input.cdl> <output.cdl>                         ")
  exit
end

fd = open(ARGV[1], "w")

######################################################################
# read
######################################################################
vdd_name           = ""
replace            = ""
cell               = ""
table              = {}
is_subckt          = true

open(ARGV[0]).each do |line|
  # not tranlated line
  if (line =~ /^ *$/) then
    fd.puts(line)
    next
  end
  
  tokens = line.split()
  if (tokens.length < 2) then
    fd.puts(line)
    next    
  end
  
  # subckt
  if (tokens[0] == ".SUBCKT") then
    is_subckt = true
    fd.puts(line)

  # multiple line
  elsif (tokens[0] == "+" && is_subckt == false) then
    replace += "+"
    tokens.shift()
    tokens.each do |token|
      replace += " "
      # VDD
      if (token =~ /^VDD=(\w*)/) then
        ret      = pad_tbl[cell]
        vdd_name = 
          if    (ret == CORE)   then "CORE_VDD"
          elsif (ret == BRIDGE) then "BRIDGE_VDD"
          else                       Regexp.last_match(1)
          end
        token    = sprintf("VDD=%s", vdd_name)
      # other power
      elsif (token =~ /VSS=(\w*)/)
        token    = "VSS=VSS"
      elsif (token =~ /VNW=(\w*)/)
        token    = sprintf("VNW=%s", vdd_name)
      elsif (token =~ /VPW=(\w*)/)
        token    = "VPW=VSS"
      elsif (token =~ /VDE=(\w*)/)
        token    = "VDE=VDE"
      end
      replace += token
    end
    replace += "\n"
    
  # first line
  else
    is_subckt = false
    fd.puts(replace)
    cell    = tokens[0]
    replace = cell
    tokens.shift()
    tokens.each do |token|
      replace += " "
      # VDD
      if (token =~ /^VDD=(\w*)/) then
        ret      = pad_tbl[cell]
        vdd_name = 
          if    (ret == CORE)   then "CORE_VDD"
          elsif (ret == BRIDGE) then "BRIDGE_VDD"
          else                       Regexp.last_match(1)
          end
        token    = sprintf("VDD=%s", vdd_name)
      # other power
      elsif (token =~ /VSS=(\w*)/)
        token    = "VSS=VSS"
      elsif (token =~ /VNW=(\w*)/)
        token    = sprintf("VNW=%s", vdd_name)
      elsif (token =~ /VPW=(\w*)/)
        token    = "VPW=VSS"
      elsif (token =~ /VDE=(\w*)/)
        token    = "VDE=VDE"
      end
      replace += token
    end
    replace += "\n"
  end
end

fd.close()
