#!/usr/bin/env ruby

######## PARAMETERS ############################################
del_cells = [
  'IOCB2ES24C0A1', 'IOCB2ESA4C0A1',
  'IOCB2ESD4C0A1', 'IOCB2ES54C0A1',
  'IOCB2ES14C0A1', 'IOCB2ESB4C0A1',
  'IOCB2ESD4C0A1'
]
cat_tails = [
  '.GLOBAL VDE'
]
del_lines = [
  /^.GLOBAL\s+VDD/,
  /^\*?.CONNECT\s*VDD\s+VDE/,
  /^\*?.CONNECT\s*VDE\s+VDD/,
  /^\*?.CONNECT\s*VDD\s+VDDL/,
  /^\*?.CONNECT\s*VDDL\s+VDD/,
  /^\*?.CONNECT\s*VDDL\s+VDE/,
  /^\*?.CONNECT\s*VDE\s+VDDL/
]

del_inst_port = {
  /^IOCB/ => ['VPW', 'VNW']
}





################################################################
load './funcs_mod_cdl.rb'

src_cdl = ARGV.shift
if (src_cdl == nil) or (src_cdl !~ /^[\w\.\/]+\.cdl$/)
  abort 'USAGE   : ' + $0 + ' SRC_CDL'
end


basedir   = File.dirname(src_cdl)
org_cdl   = src_cdl.sub(/\.cdl$/, '_org.cdl')
dst_cdl   = src_cdl.dup


cdl_stack = [File.expand_path(src_cdl)]
lines = get_lines(src_cdl)
# lines = include_file(lines, cdl_stack, basedir)

lines = del_insts(lines, del_cells)

open(dst_cdl, 'w') do |file|
  file.print lines.join("\n")
end
