#!/usr/bin/env ruby

######################################################################
# connect filler and IO Pad
#   VNW=VNW -> VNW=your_VDD  : .VDD(your_VDD)
#   VPW=VPW -> VPW=VSS
#   VDD=<right VDD>
# usage:
#   ./connect <input.cdl> <output.cdl>
######################################################################

######################################################################
# setting
######################################################################
CORE    = 0
BRIDGE  = 1
pad_tbl = {}

######################################################################
# _PAD define
######################################################################
# bottom ###################################################
pad_tbl["CORNER_B_L_PAD"]      = CORE
pad_tbl["VSS_SPACE_B0_PAD"]    = CORE
pad_tbl["DUMPDONE_PAD"]        = CORE
pad_tbl["TRANS_MODE_PAD"]      = CORE
pad_tbl["VDE_B0_PAD"]          = CORE
pad_tbl["VSS_B0_PAD"]          = CORE
pad_tbl["CORE_VDD_B0_PAD"]     = CORE
pad_tbl["WRITE_PAD"]           = CORE
pad_tbl["STROBE_PAD"]          = CORE
pad_tbl["BLOCK_PAD"]           = CORE
pad_tbl["G_BYTEENABLE[0]_PAD"] = CORE
pad_tbl["G_BYTEENABLE[1]_PAD"] = CORE
pad_tbl["G_BYTEENABLE[2]_PAD"] = CORE
pad_tbl["G_BYTEENABLE[3]_PAD"] = CORE
pad_tbl["CORE_VDD_B1_PAD"]     = CORE
pad_tbl["VSS_B1_PAD"]          = CORE
# devider ##################################################
pad_tbl["OUT_DA[0]_PAD"]       = BRIDGE
pad_tbl["OUT_DA[1]_PAD"]       = BRIDGE
pad_tbl["OUT_DA[2]_PAD"]       = BRIDGE
pad_tbl["CLK1_PAD"]            = BRIDGE
pad_tbl["OUT_DA[3]_PAD"]       = BRIDGE
pad_tbl["OUT_DA[4]_PAD"]       = BRIDGE
pad_tbl["OUT_DA[5]_PAD"]       = BRIDGE
pad_tbl["BRIDGE_VDD_B0_PAD"]   = BRIDGE
pad_tbl["VDE_B1_PAD"]          = BRIDGE
pad_tbl["VSS_B2_PAD"]          = BRIDGE
pad_tbl["OUT_DA[6]_PAD"]       = BRIDGE
pad_tbl["OUT_DA[7]_PAD"]       = BRIDGE
pad_tbl["OUT_DA[8]_PAD"]       = BRIDGE
pad_tbl["OUT_DA[9]_PAD"]       = BRIDGE
pad_tbl["OUT_DA[10]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[11]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[12]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[13]_PAD"]      = BRIDGE
pad_tbl["VSS_B3_PAD"]          = BRIDGE
pad_tbl["BRIDGE_VDD_B1_PAD"]   = BRIDGE
pad_tbl["OUT_DA[14]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[15]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[16]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[17]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[18]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[19]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[20]_PAD"]      = BRIDGE
pad_tbl["BRIDGE_VDD_B2_PAD"]   = BRIDGE
pad_tbl["VSS_B4_PAD"]          = BRIDGE
pad_tbl["VDE_B2_PAD"]          = BRIDGE
pad_tbl["OUT_DA[21]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[22]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[23]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[24]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[25]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[26]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[27]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[28]_PAD"]      = BRIDGE
pad_tbl["VSS_B5_PAD"]          = BRIDGE
pad_tbl["BRIDGE_VDD_B3_PAD"]   = BRIDGE
pad_tbl["OUT_DA[29]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[30]_PAD"]      = BRIDGE
pad_tbl["OUT_DA[31]_PAD"]      = BRIDGE
# right ####################################################
pad_tbl["CORNER_B_R_PAD"]      = BRIDGE
pad_tbl["LEAKRESET__PAD"]      = BRIDGE
pad_tbl["LEAKSET_PAD"]         = BRIDGE
pad_tbl["LEAKSTART_PAD"]       = BRIDGE
pad_tbl["LEAKDATA_PAD"]        = BRIDGE
pad_tbl["DMISS_PAD"]           = BRIDGE
pad_tbl["VDE_R0_PAD"]          = BRIDGE
pad_tbl["VSS_R0_PAD"]          = BRIDGE
pad_tbl["LEAKREADY_PAD"]       = BRIDGE
pad_tbl["DHIT_PAD"]            = BRIDGE
pad_tbl["IMISS_PAD"]           = BRIDGE
pad_tbl["IHIT_PAD"]            = BRIDGE
pad_tbl["DTLBMISS_PAD"]        = BRIDGE
pad_tbl["DTLBHIT_PAD"]         = BRIDGE
pad_tbl["ITLBMISS_PAD"]        = BRIDGE
pad_tbl["ITLBHIT_PAD"]         = BRIDGE
pad_tbl["VSS_R1_PAD"]          = BRIDGE
pad_tbl["BRIDGE_VDD_R1_PAD"]   = BRIDGE
pad_tbl["IN_D[31]_PAD"]        = BRIDGE
pad_tbl["IN_D[30]_PAD"]        = BRIDGE
pad_tbl["IN_D[29]_PAD"]        = BRIDGE
pad_tbl["IN_D[28]_PAD"]        = BRIDGE
pad_tbl["IN_D[27]_PAD"]        = BRIDGE
pad_tbl["IN_D[26]_PAD"]        = BRIDGE
# top ######################################################"
pad_tbl["VSS_SPACE_T0_PAD"]    = CORE
pad_tbl["VSS_SPACE_T1_PAD"]    = CORE
pad_tbl["VSS_SPACE_T2_PAD"]    = CORE
pad_tbl["CORE_VDD_T0_PAD"]     = CORE
pad_tbl["VSS_T0_PAD"]          = CORE
pad_tbl["HARD_INT[5]_PAD"]     = CORE
pad_tbl["HARD_INT[4]_PAD"]     = CORE
pad_tbl["HARD_INT[3]_PAD"]     = CORE
pad_tbl["HARD_INT[2]_PAD"]     = CORE
pad_tbl["HARD_INT[1]_PAD"]     = CORE
pad_tbl["HARD_INT[0]_PAD"]     = CORE
pad_tbl["NMI__PAD"]            = CORE
pad_tbl["TLB_EN_PAD"]          = CORE
pad_tbl["VDE_T0_PAD"]          = CORE
pad_tbl["VSS_T1_PAD"]          = CORE
pad_tbl["CORE_VDD_T1_PAD"]     = CORE
# divider ##################################################
pad_tbl["CACHE_EN_PAD"]        = BRIDGE
pad_tbl["MEMORYDUMP_PAD"]      = BRIDGE
pad_tbl["CLK_PAD"]             = BRIDGE
pad_tbl["RESET__PAD"]          = BRIDGE
pad_tbl["BUS_ERR_PAD"]         = BRIDGE
pad_tbl["READY_PAD"]           = BRIDGE
pad_tbl["IN_D[0]_PAD"]         = BRIDGE
pad_tbl["BRIDGE_VDD_T0_PAD"]   = BRIDGE
pad_tbl["VSS_T2_PAD"]          = BRIDGE
pad_tbl["IN_D[1]_PAD"]         = BRIDGE
pad_tbl["IN_D[2]_PAD"]         = BRIDGE
pad_tbl["IN_D[3]_PAD"]         = BRIDGE
pad_tbl["IN_D[4]_PAD"]         = BRIDGE
pad_tbl["IN_D[5]_PAD"]         = BRIDGE
pad_tbl["IN_D[6]_PAD"]         = BRIDGE
pad_tbl["IN_D[7]_PAD"]         = BRIDGE
pad_tbl["BRIDGE_VDD_T1_PAD"]   = BRIDGE
pad_tbl["VSS_T3_PAD"]          = BRIDGE
pad_tbl["VDE_T1_PAD"]          = BRIDGE
pad_tbl["IN_D[8]_PAD"]         = BRIDGE
pad_tbl["IN_D[9]_PAD"]         = BRIDGE
pad_tbl["IN_D[10]_PAD"]        = BRIDGE
pad_tbl["IN_D[11]_PAD"]        = BRIDGE
pad_tbl["IN_D[12]_PAD"]        = BRIDGE
pad_tbl["IN_D[13]_PAD"]        = BRIDGE
pad_tbl["IN_D[14]_PAD"]        = BRIDGE
pad_tbl["IN_D[15]_PAD"]        = BRIDGE
pad_tbl["VSS_T4_PAD"]          = BRIDGE
pad_tbl["BRIDGE_VDD_T2_PAD"]   = BRIDGE
pad_tbl["IN_D[16]_PAD"]        = BRIDGE
pad_tbl["IN_D[17]_PAD"]        = BRIDGE
pad_tbl["IN_D[18]_PAD"]        = BRIDGE
pad_tbl["IN_D[19]_PAD"]        = BRIDGE
pad_tbl["IN_D[20]_PAD"]        = BRIDGE
pad_tbl["IN_D[21]_PAD"]        = BRIDGE
pad_tbl["IN_D[22]_PAD"]        = BRIDGE
pad_tbl["BRIDGE_VDD_T3_PAD"]   = BRIDGE
pad_tbl["VSS_T5_PAD"]          = BRIDGE
pad_tbl["VDE_T2_PAD"]          = BRIDGE
pad_tbl["IN_D[23]_PAD"]        = BRIDGE
pad_tbl["IN_D[24]_PAD"]        = BRIDGE
pad_tbl["IN_D[25]_PAD"]        = BRIDGE
pad_tbl["CORNER_T_R_PAD"]      = BRIDGE
# left #####################################################
pad_tbl["VSS_SPACE_L0_PAD"]    = CORE
pad_tbl["VSS_SPACE_L1_PAD"]    = CORE
pad_tbl["VSS_SPACE_L2_PAD"]    = CORE
pad_tbl["VSS_SPACE_L3_PAD"]    = CORE
pad_tbl["VSS_SPACE_L4_PAD"]    = CORE
pad_tbl["VSS_SPACE_L5_PAD"]    = CORE
pad_tbl["CORE_VDD_L0_PAD"]     = CORE
pad_tbl["VSS_L0_PAD"]          = CORE
pad_tbl["VSS_SPACE_L6_PAD"]    = CORE
pad_tbl["SLEEPCON[0]_PAD"]     = CORE
pad_tbl["SLEEPCON[1]_PAD"]     = CORE
pad_tbl["SLEEPCON[2]_PAD"]     = CORE
pad_tbl["SLEEPCON[3]_PAD"]     = CORE
pad_tbl["CP0_CON_PAD"]         = CORE
pad_tbl["VSS_SPACE_L7_PAD"]    = CORE
pad_tbl["CORE_VDD_L1_PAD"]     = CORE
pad_tbl["VSS_L1_PAD"]          = CORE
pad_tbl["VDE_L0_PAD"]          = CORE
pad_tbl["VSS_SPACE_L8_PAD"]    = CORE
pad_tbl["VSS_SPACE_L9_PAD"]    = CORE
pad_tbl["VSS_SPACE_L10_PAD"]   = CORE
pad_tbl["VSS_SPACE_L11_PAD"]   = CORE
pad_tbl["VSS_SPACE_L12_PAD"]   = CORE
pad_tbl["CORNER_T_L_PAD"]      = CORE

######################################################################
# _WIRE_PAD define
######################################################################
# bottom ###################################################
pad_tbl["CORNER_B_L_WIRE_PAD"]      = CORE
pad_tbl["VSS_SPACE_B0_WIRE_PAD"]    = CORE
pad_tbl["DUMPDONE_WIRE_PAD"]        = CORE
pad_tbl["TRANS_MODE_WIRE_PAD"]      = CORE
pad_tbl["VDE_B0_WIRE_PAD"]          = CORE
pad_tbl["VSS_B0_WIRE_PAD"]          = CORE
pad_tbl["CORE_VDD_B0_WIRE_PAD"]     = CORE
pad_tbl["WRITE_WIRE_PAD"]           = CORE
pad_tbl["STROBE_WIRE_PAD"]          = CORE
pad_tbl["BLOCK_WIRE_PAD"]           = CORE
pad_tbl["G_BYTEENABLE[0]_WIRE_PAD"] = CORE
pad_tbl["G_BYTEENABLE[1]_WIRE_PAD"] = CORE
pad_tbl["G_BYTEENABLE[2]_WIRE_PAD"] = CORE
pad_tbl["G_BYTEENABLE[3]_WIRE_PAD"] = CORE
pad_tbl["CORE_VDD_B1_WIRE_PAD"]     = CORE
pad_tbl["VSS_B1_WIRE_PAD"]          = CORE
# devider ##################################################
pad_tbl["OUT_DA[0]_WIRE_PAD"]       = BRIDGE
pad_tbl["OUT_DA[1]_WIRE_PAD"]       = BRIDGE
pad_tbl["OUT_DA[2]_WIRE_PAD"]       = BRIDGE
pad_tbl["CLK1_WIRE_PAD"]            = BRIDGE
pad_tbl["OUT_DA[3]_WIRE_PAD"]       = BRIDGE
pad_tbl["OUT_DA[4]_WIRE_PAD"]       = BRIDGE
pad_tbl["OUT_DA[5]_WIRE_PAD"]       = BRIDGE
pad_tbl["BRIDGE_VDD_B0_WIRE_PAD"]   = BRIDGE
pad_tbl["VDE_B1_WIRE_PAD"]          = BRIDGE
pad_tbl["VSS_B2_WIRE_PAD"]          = BRIDGE
pad_tbl["OUT_DA[6]_WIRE_PAD"]       = BRIDGE
pad_tbl["OUT_DA[7]_WIRE_PAD"]       = BRIDGE
pad_tbl["OUT_DA[8]_WIRE_PAD"]       = BRIDGE
pad_tbl["OUT_DA[9]_WIRE_PAD"]       = BRIDGE
pad_tbl["OUT_DA[10]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[11]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[12]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[13]_WIRE_PAD"]      = BRIDGE
pad_tbl["VSS_B3_WIRE_PAD"]          = BRIDGE
pad_tbl["BRIDGE_VDD_B1_WIRE_PAD"]   = BRIDGE
pad_tbl["OUT_DA[14]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[15]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[16]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[17]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[18]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[19]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[20]_WIRE_PAD"]      = BRIDGE
pad_tbl["BRIDGE_VDD_B2_WIRE_PAD"]   = BRIDGE
pad_tbl["VSS_B4_WIRE_PAD"]          = BRIDGE
pad_tbl["VDE_B2_WIRE_PAD"]          = BRIDGE
pad_tbl["OUT_DA[21]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[22]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[23]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[24]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[25]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[26]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[27]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[28]_WIRE_PAD"]      = BRIDGE
pad_tbl["VSS_B5_WIRE_PAD"]          = BRIDGE
pad_tbl["BRIDGE_VDD_B3_WIRE_PAD"]   = BRIDGE
pad_tbl["OUT_DA[29]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[30]_WIRE_PAD"]      = BRIDGE
pad_tbl["OUT_DA[31]_WIRE_PAD"]      = BRIDGE
# right ####################################################
pad_tbl["CORNER_B_R_WIRE_PAD"]      = BRIDGE
pad_tbl["LEAKRESET__WIRE_PAD"]      = BRIDGE
pad_tbl["LEAKSET_WIRE_PAD"]         = BRIDGE
pad_tbl["LEAKSTART_WIRE_PAD"]       = BRIDGE
pad_tbl["LEAKDATA_WIRE_PAD"]        = BRIDGE
pad_tbl["DMISS_WIRE_PAD"]           = BRIDGE
pad_tbl["VDE_R0_WIRE_PAD"]          = BRIDGE
pad_tbl["VSS_R0_WIRE_PAD"]          = BRIDGE
pad_tbl["LEAKREADY_WIRE_PAD"]       = BRIDGE
pad_tbl["DHIT_WIRE_PAD"]            = BRIDGE
pad_tbl["IMISS_WIRE_PAD"]           = BRIDGE
pad_tbl["IHIT_WIRE_PAD"]            = BRIDGE
pad_tbl["DTLBMISS_WIRE_PAD"]        = BRIDGE
pad_tbl["DTLBHIT_WIRE_PAD"]         = BRIDGE
pad_tbl["ITLBMISS_WIRE_PAD"]        = BRIDGE
pad_tbl["ITLBHIT_WIRE_PAD"]         = BRIDGE
pad_tbl["VSS_R1_WIRE_PAD"]          = BRIDGE
pad_tbl["BRIDGE_VDD_R1_WIRE_PAD"]   = BRIDGE
pad_tbl["IN_D[31]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[30]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[29]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[28]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[27]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[26]_WIRE_PAD"]        = BRIDGE
# top ######################################################"
pad_tbl["VSS_SPACE_T0_WIRE_PAD"]    = CORE
pad_tbl["VSS_SPACE_T1_WIRE_PAD"]    = CORE
pad_tbl["VSS_SPACE_T2_WIRE_PAD"]    = CORE
pad_tbl["CORE_VDD_T0_WIRE_PAD"]     = CORE
pad_tbl["VSS_T0_WIRE_PAD"]          = CORE
pad_tbl["HARD_INT[5]_WIRE_PAD"]     = CORE
pad_tbl["HARD_INT[4]_WIRE_PAD"]     = CORE
pad_tbl["HARD_INT[3]_WIRE_PAD"]     = CORE
pad_tbl["HARD_INT[2]_WIRE_PAD"]     = CORE
pad_tbl["HARD_INT[1]_WIRE_PAD"]     = CORE
pad_tbl["HARD_INT[0]_WIRE_PAD"]     = CORE
pad_tbl["NMI__WIRE_PAD"]            = CORE
pad_tbl["TLB_EN_WIRE_PAD"]          = CORE
pad_tbl["VDE_T0_WIRE_PAD"]          = CORE
pad_tbl["VSS_T1_WIRE_PAD"]          = CORE
pad_tbl["CORE_VDD_T1_WIRE_PAD"]     = CORE
# divider ##################################################
pad_tbl["CACHE_EN_WIRE_PAD"]        = BRIDGE
pad_tbl["MEMORYDUMP_WIRE_PAD"]      = BRIDGE
pad_tbl["CLK_WIRE_PAD"]             = BRIDGE
pad_tbl["RESET__WIRE_PAD"]          = BRIDGE
pad_tbl["BUS_ERR_WIRE_PAD"]         = BRIDGE
pad_tbl["READY_WIRE_PAD"]           = BRIDGE
pad_tbl["IN_D[0]_WIRE_PAD"]         = BRIDGE
pad_tbl["BRIDGE_VDD_T0_WIRE_PAD"]   = BRIDGE
pad_tbl["VSS_T2_WIRE_PAD"]          = BRIDGE
pad_tbl["IN_D[1]_WIRE_PAD"]         = BRIDGE
pad_tbl["IN_D[2]_WIRE_PAD"]         = BRIDGE
pad_tbl["IN_D[3]_WIRE_PAD"]         = BRIDGE
pad_tbl["IN_D[4]_WIRE_PAD"]         = BRIDGE
pad_tbl["IN_D[5]_WIRE_PAD"]         = BRIDGE
pad_tbl["IN_D[6]_WIRE_PAD"]         = BRIDGE
pad_tbl["IN_D[7]_WIRE_PAD"]         = BRIDGE
pad_tbl["BRIDGE_VDD_T1_WIRE_PAD"]   = BRIDGE
pad_tbl["VSS_T3_WIRE_PAD"]          = BRIDGE
pad_tbl["VDE_T1_WIRE_PAD"]          = BRIDGE
pad_tbl["IN_D[8]_WIRE_PAD"]         = BRIDGE
pad_tbl["IN_D[9]_WIRE_PAD"]         = BRIDGE
pad_tbl["IN_D[10]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[11]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[12]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[13]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[14]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[15]_WIRE_PAD"]        = BRIDGE
pad_tbl["VSS_T4_WIRE_PAD"]          = BRIDGE
pad_tbl["BRIDGE_VDD_T2_WIRE_PAD"]   = BRIDGE
pad_tbl["IN_D[16]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[17]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[18]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[19]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[20]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[21]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[22]_WIRE_PAD"]        = BRIDGE
pad_tbl["BRIDGE_VDD_T3_WIRE_PAD"]   = BRIDGE
pad_tbl["VSS_T5_WIRE_PAD"]          = BRIDGE
pad_tbl["VDE_T2_WIRE_PAD"]          = BRIDGE
pad_tbl["IN_D[23]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[24]_WIRE_PAD"]        = BRIDGE
pad_tbl["IN_D[25]_WIRE_PAD"]        = BRIDGE
pad_tbl["CORNER_T_R_WIRE_PAD"]      = BRIDGE
# left #####################################################
pad_tbl["VSS_SPACE_L0_WIRE_PAD"]    = CORE
pad_tbl["VSS_SPACE_L1_WIRE_PAD"]    = CORE
pad_tbl["VSS_SPACE_L2_WIRE_PAD"]    = CORE
pad_tbl["VSS_SPACE_L3_WIRE_PAD"]    = CORE
pad_tbl["VSS_SPACE_L4_WIRE_PAD"]    = CORE
pad_tbl["VSS_SPACE_L5_WIRE_PAD"]    = CORE
pad_tbl["CORE_VDD_L0_WIRE_PAD"]     = CORE
pad_tbl["VSS_L0_WIRE_PAD"]          = CORE
pad_tbl["VSS_SPACE_L6_WIRE_PAD"]    = CORE
pad_tbl["SLEEPCON[0]_WIRE_PAD"]     = CORE
pad_tbl["SLEEPCON[1]_WIRE_PAD"]     = CORE
pad_tbl["SLEEPCON[2]_WIRE_PAD"]     = CORE
pad_tbl["SLEEPCON[3]_WIRE_PAD"]     = CORE
pad_tbl["CP0_CON_WIRE_PAD"]         = CORE
pad_tbl["VSS_SPACE_L7_WIRE_PAD"]    = CORE
pad_tbl["CORE_VDD_L1_WIRE_PAD"]     = CORE
pad_tbl["VSS_L1_WIRE_PAD"]          = CORE
pad_tbl["VDE_L0_WIRE_PAD"]          = CORE
pad_tbl["VSS_SPACE_L8_WIRE_PAD"]    = CORE
pad_tbl["VSS_SPACE_L9_WIRE_PAD"]    = CORE
pad_tbl["VSS_SPACE_L10_WIRE_PAD"]   = CORE
pad_tbl["VSS_SPACE_L11_WIRE_PAD"]   = CORE
pad_tbl["VSS_SPACE_L12_WIRE_PAD"]   = CORE
pad_tbl["CORNER_T_L_WIRE_PAD"]      = CORE

######################################################################
# argument check
######################################################################
if (ARGV.size < 2) then
  puts("connect filler and IO pad                                       ")
  puts("  VNW=VNW -> VNW=your_VDD  : .VDD(your_VDD)                     ")
  puts("  VPW=VPW -> VPW=VSS                                            ")
  puts("  VDD=VDD -> VDD=right VDD                                      ")
  puts("usage:                                                          ")
  puts("  ./connect.rb <input.cdl> <output.cdl>                         ")
  exit
end

fd             = open(ARGV[1], "w")

######################################################################
# read
######################################################################
vdd_name           = ""
replace            = ""
cell               = ""
table              = {}

open(ARGV[0]).each do |line|
  if (line =~ /^ *$/) then
    fd.puts(line)
    flag_v1 = false
    flag_v2 = false
    next
  end
  
  tokens = line.split()
  
  # multiple line
  if (tokens[0] == "+") then

  # first line
  else
    cell    = tokens[0]
    replace = tokens.shift()
    tokens.each do |token|
      replace += " "
      if (token =~ /VDD=(\w*)/) then
        if (vdd_flag) then
          token = sprintf("VDD=%s", vdd_name)
        else
          vdd_name = Regexp.last_match(1)
        end
  end

  tokens.each do |token|
    replace += " "
      if (token =~ /VDD=(\w*)/) then
        if (vdd_flag) then
          token = sprintf("VDD=%s", vdd_name)
        else
          vdd_name = Regexp.last_match(1)
        end
      elsif (token == "VNW=VNW") then
        token = sprintf("VNW=%s", vdd_name)
      elsif (token == "VPW=VPW") then
        token = "VPW=VSS"
      elsif (token =~ /VDE=/) then
        token = "VDE=VDE"
      end
        replace += token
    end
    replace += "\n"
  else
    replace = line
  end

  next if (replace =~ /\+ *$/) 
  fd.puts(replace)
end

fd.close()
