#!/bin/bash -f

##
## run_drc.sh
## run Design Rule Check with all rule check file
## written by Masayuki KIMURA
##

rule_dir="\/home\/vdec\/lib\/ux8l\/DRC_Rule"
rule_lists="drc_add.V02R00.cal.ux8_svenc \
    drc_core_beol.7cu_pm_L5S1T1G0.V03R00.cal.ux8_svenc \
    drc_core_feol.V03R00.cal.ux8_svenc \
    drc_pg_latch-up.7cu_pm_L5S1T1G0.V01R00.cal.ux8_svenc \
    extraordinary_figure_check.rule_svenc \
    lvs.7cu_pm_L5S1T1G0.V03R00.cal.ux8l_ld_svenc \
    drc_macro_den.7cu_pm_L5S1T1G0.V02R00.cal.ux8_svenc"

design_name=$1
gds_file=$1".gds"

rm -f ${design_name}_DRC.summary
touch ${design_name}_DRC.summary

for rule_file in $rule_lists
do
  sed 's/gds_file/'$gds_file'/g' ./misc_scripts/drc.rul | \
      sed 's/rule_dir/'$rule_dir'/g' | \
      sed 's/rule_file/'$rule_file'/g' | \
      sed 's/design_name/'$design_name'/g' > rule/${design_name}_drc_${rule_file}.rul
  calibre -drc -hier -nowait rule/${design_name}_drc_${rule_file}.rul -64 -turbo 8 | tee log/${design_name}_${rule_file}.log
  # calibre -drc -nowait rule/${design_name}_drc_${rule_file}.rul -64 | tee log/${design_name}_${rule_file}.log
  echo "#####" >> ${design_name}_DRC.summary
  echo "Rule Check ${rule_file}" >> ${design_name}_DRC.summary
  grep "TOTAL DRC Results Generated:" ${design_name}_${rule_file}.sum >> ${design_name}_DRC.summary
  echo "  "
done

